//-------------------------------------------------------------------------------------------------
// KS0108 driver library  
// www.farzadsw.ir
//-------------------------------------------------------------------------------------------------
/* ----------------------------------------------------------------------------
library name :KS0108.h - by this library you can work with GLCD KS0108 driver 
this library is provide by farzad ahmadi (www.farzadsw.ir) for at91sam series 
you can edit , remove & change all parts af that .also you can download other 
library for other atmel & nxp products (AT91-LPC series)from WWW.IRANMICRO.IR 
you can access to descriptions all programs library in PMM11 magazine . for 
more information please visit : www.iranmicro.ir/forum/forumdisplay.php?f=221
----------------------------------------------------------------------------*/
#ifndef KS0108_H
#define KS0108_H


#define KS0108_SCREEN_WIDTH		128
#define KS0108_SCREEN_HEIGHT	64


#define DISPLAY_SET_Y       0x40
#define DISPLAY_SET_X       0xB8
#define DISPLAY_START_LINE  0xC0
#define DISPLAY_ON_CMD		0x3E
  #define ON	0x01
  #define OFF	0x00
#define DISPLAY_STATUS_BUSY	0x80

void GLCD_Delay(void);
void GLCD_EnableController(unsigned char ) ;
void GLCD_DisableController(unsigned char );
unsigned char GLCD_ReadStatus(unsigned char );
void GLCD_WriteCommand(unsigned char , unsigned char ) ;
unsigned char GLCD_ReadData(void);
void GLCD_WriteData(unsigned char )	;
void GLCD_InitalizePorts(void);
unsigned char GLCD_ReadByteFromROMMemory(char *);


void GLCD_Initialize(void);
void GLCD_ClearScreen(void);
void GLCD_WriteChar(char );
void GLCD_WriteString(char *);
void GLCD_GoTo(unsigned char, unsigned char);
void GLCD_Bitmap(char *, unsigned char, unsigned char, unsigned char, unsigned char);
void GLCD_SetPixel(unsigned char , unsigned char , unsigned char );
void GLCD_Rectangle(unsigned char , unsigned char , unsigned char , unsigned char );


void GLCD_Circle(unsigned char , unsigned char  ,unsigned char );



void GLCD_Line(unsigned int ,unsigned int ,unsigned int ,unsigned int );

#include "font5x8.h"
#ifdef GLCD_DATAPORT_A
#define KS0108_DATA_SET (*AT91C_PIOA_SODR)
#define KS0108_DATA_CLR (*AT91C_PIOA_CODR)
#define KS0108_DATA_OUT (*AT91C_PIOA_OER)
#define KS0108_DATA_INP (*AT91C_PIOA_ODR)
#define KS0108_DATA_PIN (*AT91C_PIOA_PDSR)
#define KS0108_DATA_IO_EN (*AT91C_PIOA_PER)		
#define KS0108_CTRL_SET (*AT91C_PIOA_SODR)
#define KS0108_CTRL_CLR (*AT91C_PIOA_CODR)
#define KS0108_CTRL_OUT (*AT91C_PIOA_OER)
#define KS0108_CTRL_INP (*AT91C_PIOA_ODR)
#define KS0108_CTRL_PIN (*AT91C_PIOA_PDSR)
#define KS0108_CTRL_IO_EN (*AT91C_PIOA_PER)
#endif
#ifdef GLCD_DATAPORT_B
#define KS0108_DATA_SET (*AT91C_PIOB_SODR)
#define KS0108_DATA_CLR (*AT91C_PIOB_CODR)
#define KS0108_DATA_OUT (*AT91C_PIOB_OER)
#define KS0108_DATA_INP (*AT91C_PIOB_ODR)
#define KS0108_DATA_PIN (*AT91C_PIOB_PDSR)
#define KS0108_DATA_IO_EN (*AT91C_PIOB_PER)		
#define KS0108_CTRL_SET (*AT91C_PIOB_SODR)
#define KS0108_CTRL_CLR (*AT91C_PIOB_CODR)
#define KS0108_CTRL_OUT (*AT91C_PIOB_OER)
#define KS0108_CTRL_INP (*AT91C_PIOB_ODR)
#define KS0108_CTRL_PIN (*AT91C_PIOB_PDSR)
#define KS0108_CTRL_IO_EN (*AT91C_PIOB_PER)
#endif
#define KS0108_RS      (1 << GLCD_RS)
#define KS0108_RW      (1 << GLCD_RW)
#define KS0108_EN      (1 << GLCD_EN)
#define KS0108_CS1     (1 << GLCD_CS1)
#define KS0108_CS2     (1 << GLCD_CS2)			
#define KS0108_CS3     (1 << GLCD_CS3)

		//FAGHAT baraye lcd ha ee ba 3 ta cs (lcd haye mamuli 2 ta cs darand)
// pin reset LCD be vcc motasel shavad

#define DISPLAY_STATUS_BUSY	0x80


//-------------------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------------------
unsigned char screen_x = 0, screen_y = 0;
//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
void GLCD_Initialize(void)
{
unsigned char i;
GLCD_InitalizePorts();
for(i = 0; i < 3; i++)
  GLCD_WriteCommand((DISPLAY_ON_CMD | ON), i);
}
//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
void GLCD_GoTo(unsigned char x, unsigned char y)
{
unsigned char i;
screen_x = x;
screen_y = y;

for(i = 0; i < KS0108_SCREEN_WIDTH/64; i++)
  {
  GLCD_WriteCommand(DISPLAY_SET_Y | 0,i);
  GLCD_WriteCommand(DISPLAY_SET_X | y,i);
  GLCD_WriteCommand(DISPLAY_START_LINE | 0,i);
  }
GLCD_WriteCommand(DISPLAY_SET_Y | (x % 64), (x / 64));
GLCD_WriteCommand(DISPLAY_SET_X | y, (x / 64));
}
//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
void GLCD_ClearScreen(void)
{
unsigned char i, j;
for(j = 0; j < KS0108_SCREEN_HEIGHT/8; j++)
  {
  GLCD_GoTo(0,j);
  for(i = 0; i < KS0108_SCREEN_WIDTH; i++)
    GLCD_WriteData(0x00);
  }
}
//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
void GLCD_WriteChar(char charToWrite)
{
int i;
charToWrite -= 32; 
for(i = 0; i < 5; i++) 
  GLCD_WriteData(GLCD_ReadByteFromROMMemory((char *)((int)font5x8 + (5 * charToWrite) + i))); 
GLCD_WriteData(0x00);
}
//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
void GLCD_WriteString(char * stringToWrite)
{
while(*stringToWrite)
  GLCD_WriteChar(*stringToWrite++);
}
//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
void GLCD_SetPixel(unsigned char x, unsigned char y, unsigned char color)
{
unsigned char tmp;
GLCD_GoTo(x, (y / 8));
tmp = GLCD_ReadData();
GLCD_GoTo(x, (y / 8));
tmp = GLCD_ReadData();
GLCD_GoTo(x, (y / 8));
tmp |= (1 << (y % 8));
GLCD_WriteData(tmp);
}
//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
void GLCD_Bitmap(char * bmp, unsigned char x, unsigned char y, unsigned char dx, unsigned char dy)
{
unsigned char i, j;
for(j = 0; j < dy / 8; j++)
  {
  GLCD_GoTo(x,y + j);
  for(i = 0; i < dx; i++) 
    GLCD_WriteData(GLCD_ReadByteFromROMMemory(bmp++));
  }
}
//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------


//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------

unsigned char GLCD_ReadByteFromROMMemory(char * ptr)
{
return *(ptr);
}


//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
void GLCD_InitalizePorts(void)
{
//Init();
*AT91C_PMC_PCER = (1 << AT91C_ID_PIOA);
KS0108_CTRL_OUT |= (KS0108_CS1 | KS0108_CS2 | KS0108_CS3 | KS0108_RS | KS0108_RW | KS0108_EN);
KS0108_CTRL_SET = (KS0108_CS1 | KS0108_CS2 | KS0108_CS3);
}


//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
void GLCD_WriteData(unsigned char dataToWrite)
{
while(GLCD_ReadStatus(screen_x / 64)&DISPLAY_STATUS_BUSY);
KS0108_DATA_OUT |= (0xFF << GLCD_D0);
KS0108_CTRL_CLR = KS0108_RW;
KS0108_CTRL_SET = KS0108_RS;

KS0108_DATA_SET = (dataToWrite << GLCD_D0);
dataToWrite ^= 0xFF;
KS0108_DATA_CLR = (dataToWrite << GLCD_D0);

GLCD_EnableController(screen_x / 64);
KS0108_CTRL_SET = KS0108_EN;
GLCD_Delay();
KS0108_CTRL_CLR = KS0108_EN;
GLCD_DisableController(screen_x / 64);
screen_x++;
}


//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
unsigned char GLCD_ReadData(void)
{
unsigned char data;
while(GLCD_ReadStatus(screen_x / 64)&DISPLAY_STATUS_BUSY);
KS0108_DATA_INP |= (0xFF << GLCD_D0);
KS0108_CTRL_SET = (KS0108_RW | KS0108_RS);
GLCD_EnableController(screen_x / 64);
//GLCD_Delay();
KS0108_CTRL_SET = KS0108_EN;
GLCD_Delay();
data = (KS0108_DATA_PIN >>  GLCD_D0);
KS0108_CTRL_CLR = KS0108_EN;
GLCD_DisableController(screen_x / 64);
screen_x++;
return data;
}


//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
void GLCD_WriteCommand(unsigned char commandToWrite, unsigned char controller)
{
while(GLCD_ReadStatus(controller)&DISPLAY_STATUS_BUSY);
KS0108_DATA_OUT |= (0xFF << GLCD_D0);
KS0108_CTRL_CLR = (KS0108_RW | KS0108_RS);
GLCD_EnableController(controller);

KS0108_DATA_SET = (commandToWrite << GLCD_D0);
commandToWrite ^= 0xFF;
KS0108_DATA_CLR = (commandToWrite << GLCD_D0);

KS0108_CTRL_SET = KS0108_EN;
GLCD_Delay();
KS0108_CTRL_CLR = KS0108_EN;
GLCD_DisableController(controller);
}


//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
unsigned char GLCD_ReadStatus(unsigned char controller)
{
unsigned char status;
KS0108_DATA_INP |= (0xFF << GLCD_D0);
KS0108_CTRL_SET = KS0108_RW;
KS0108_CTRL_CLR = KS0108_RS;
GLCD_EnableController(controller);
KS0108_CTRL_SET = KS0108_EN;
GLCD_Delay();
status = (KS0108_DATA_PIN >> GLCD_D0);
KS0108_CTRL_CLR = KS0108_EN;
GLCD_DisableController(controller);
return status;
}


//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
void GLCD_DisableController(unsigned char controller)
{
switch(controller){
	case 0 : KS0108_CTRL_SET = KS0108_CS1; break;
	case 1 : KS0108_CTRL_SET = KS0108_CS2; break;
	case 2 : KS0108_CTRL_SET = KS0108_CS3; break;
	}
}



//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
void GLCD_EnableController(unsigned char controller)
{
switch(controller){
	case 0 : KS0108_CTRL_CLR = KS0108_CS1; break;
	case 1 : KS0108_CTRL_CLR = KS0108_CS2; break;
	case 2 : KS0108_CTRL_CLR = KS0108_CS3; break;
	}
}


 
//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
void GLCD_Delay(void)
{
char i;

for(i=0 ; i<10 ;i++);
}



extern void GLCD_SetPixel(unsigned char x, unsigned char y, unsigned char color);

const unsigned char color = 1;
const unsigned char clear = 0;



//


void GLCD_Rectangle(unsigned char x, unsigned char y, unsigned char b, unsigned char a)
{
  unsigned char j; 
  for (j = 0; j < a; j++) {
		GLCD_SetPixel(x, y + j, clear);
		GLCD_SetPixel(x + b - 1, y + j, clear);
	}
 
  for (j = 0; j < b; j++)	{
		GLCD_SetPixel(x + j, y, clear);
		GLCD_SetPixel(x + j, y + a - 1, clear);
	}
}


  


void GLCD_Circle(unsigned char cx, unsigned char cy ,unsigned char radius)
{
int x, y, xchange, ychange, radiusError;
x = radius;
y = 0;
xchange = 1 - 2 * radius;
ychange = 1;
radiusError = 0;
while(x >= y)
  {
  GLCD_SetPixel(cx+x, cy+y, color); 
  GLCD_SetPixel(cx-x, cy+y, color); 
  GLCD_SetPixel(cx-x, cy-y, color);
  GLCD_SetPixel(cx+x, cy-y, color); 
  GLCD_SetPixel(cx+y, cy+x, color); 
  GLCD_SetPixel(cx-y, cy+x, color); 
  GLCD_SetPixel(cx-y, cy-x, color); 
  GLCD_SetPixel(cx+y, cy-x, color); 
  y++;
  radiusError += ychange;
  ychange += 2;
  if ( 2*radiusError + xchange > 0 )
    {
    x--;
	radiusError += xchange;
	xchange += 2;
	}
  }
}
//

void GLCD_Line(unsigned int X1,unsigned int Y1,unsigned int X2,unsigned int Y2)
{
int CurrentX, CurrentY, Xinc, Yinc, 
    Dx, Dy, TwoDx, TwoDy, 
	TwoDxAccumulatedError, TwoDyAccumulatedError;

Dx = (X2-X1); 
Dy = (Y2-Y1); 

TwoDx = Dx + Dx; 
TwoDy = Dy + Dy; 

CurrentX = X1; 
CurrentY = Y1; 

Xinc = 1;  
Yinc = 1; 

if(Dx < 0) 
  {
  Xinc = -1; 
  Dx = -Dx;  
  TwoDx = -TwoDx; 
  }

if (Dy < 0) 
  {
  Yinc = -1; 
  Dy = -Dy; 
  TwoDy = -TwoDy; 
  }

GLCD_SetPixel(X1,Y1, color); 

if ((Dx != 0) || (Dy != 0))
  {
 
  if (Dy <= Dx) 
    { 
    TwoDxAccumulatedError = 0;  
    do 
	  {
      CurrentX += Xinc; 
      TwoDxAccumulatedError += TwoDy;
      if(TwoDxAccumulatedError > Dx) 
        {
        CurrentY += Yinc; 
        TwoDxAccumulatedError -= TwoDx; 
        }
       GLCD_SetPixel(CurrentX,CurrentY, color);
       }while (CurrentX != X2); 
     }
   else 
      {
      TwoDyAccumulatedError = 0; 
      do 
	    {
        CurrentY += Yinc; 
        TwoDyAccumulatedError += TwoDx;
        if(TwoDyAccumulatedError>Dy) 
          {
          CurrentX += Xinc;
          TwoDyAccumulatedError -= TwoDy;
          }
         GLCD_SetPixel(CurrentX,CurrentY, color); 
         }while (CurrentY != Y2);
    }
  }
}
//











#endif
